Create App
curl --request POST \
--url https://rest.cerebrium.ai/v2/projects/{project_id}/apps \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"cliVersion": "<string>",
"name": "<string>",
"baseImage": "<string>",
"cerebrium_toml": "<string>",
"compute": "<array>",
"computeTier": "<string>",
"cooldownPeriodSeconds": 123,
"cpu": 123,
"deploymentInitializationTimeout": 123,
"disableAuth": true,
"dockerAuth": "<string>",
"dockerfilePath": "<string>",
"entrypoint": "<array>",
"evaluationIntervalSeconds": 123,
"gpuCount": 123,
"healthcheckEndpoint": "<string>",
"loadBalancingAlgorithm": "<string>",
"logLevel": "<string>",
"maxReplicaCount": 123,
"memory": 123,
"minReplicaCount": 123,
"partialUpload": true,
"port": 123,
"provider": "<string>",
"pythonVersion": "<string>",
"readycheckEndpoint": "<string>",
"region": "<string>",
"replicaConcurrency": 123,
"responseGracePeriodSeconds": 123,
"rollOutDurationSeconds": 123,
"runtime": "<string>",
"scalingBuffer": 123,
"scalingMetric": "<string>",
"scalingTarget": 123,
"useUv": true
}
'import requests
url = "https://rest.cerebrium.ai/v2/projects/{project_id}/apps"
payload = {
"cliVersion": "<string>",
"name": "<string>",
"baseImage": "<string>",
"cerebrium_toml": "<string>",
"compute": "<array>",
"computeTier": "<string>",
"cooldownPeriodSeconds": 123,
"cpu": 123,
"deploymentInitializationTimeout": 123,
"disableAuth": True,
"dockerAuth": "<string>",
"dockerfilePath": "<string>",
"entrypoint": "<array>",
"evaluationIntervalSeconds": 123,
"gpuCount": 123,
"healthcheckEndpoint": "<string>",
"loadBalancingAlgorithm": "<string>",
"logLevel": "<string>",
"maxReplicaCount": 123,
"memory": 123,
"minReplicaCount": 123,
"partialUpload": True,
"port": 123,
"provider": "<string>",
"pythonVersion": "<string>",
"readycheckEndpoint": "<string>",
"region": "<string>",
"replicaConcurrency": 123,
"responseGracePeriodSeconds": 123,
"rollOutDurationSeconds": 123,
"runtime": "<string>",
"scalingBuffer": 123,
"scalingMetric": "<string>",
"scalingTarget": 123,
"useUv": True
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
cliVersion: '<string>',
name: '<string>',
baseImage: '<string>',
cerebrium_toml: '<string>',
compute: '<array>',
computeTier: '<string>',
cooldownPeriodSeconds: 123,
cpu: 123,
deploymentInitializationTimeout: 123,
disableAuth: true,
dockerAuth: '<string>',
dockerfilePath: '<string>',
entrypoint: '<array>',
evaluationIntervalSeconds: 123,
gpuCount: 123,
healthcheckEndpoint: '<string>',
loadBalancingAlgorithm: '<string>',
logLevel: '<string>',
maxReplicaCount: 123,
memory: 123,
minReplicaCount: 123,
partialUpload: true,
port: 123,
provider: '<string>',
pythonVersion: '<string>',
readycheckEndpoint: '<string>',
region: '<string>',
replicaConcurrency: 123,
responseGracePeriodSeconds: 123,
rollOutDurationSeconds: 123,
runtime: '<string>',
scalingBuffer: 123,
scalingMetric: '<string>',
scalingTarget: 123,
useUv: true
})
};
fetch('https://rest.cerebrium.ai/v2/projects/{project_id}/apps', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://rest.cerebrium.ai/v2/projects/{project_id}/apps",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'cliVersion' => '<string>',
'name' => '<string>',
'baseImage' => '<string>',
'cerebrium_toml' => '<string>',
'compute' => '<array>',
'computeTier' => '<string>',
'cooldownPeriodSeconds' => 123,
'cpu' => 123,
'deploymentInitializationTimeout' => 123,
'disableAuth' => true,
'dockerAuth' => '<string>',
'dockerfilePath' => '<string>',
'entrypoint' => '<array>',
'evaluationIntervalSeconds' => 123,
'gpuCount' => 123,
'healthcheckEndpoint' => '<string>',
'loadBalancingAlgorithm' => '<string>',
'logLevel' => '<string>',
'maxReplicaCount' => 123,
'memory' => 123,
'minReplicaCount' => 123,
'partialUpload' => true,
'port' => 123,
'provider' => '<string>',
'pythonVersion' => '<string>',
'readycheckEndpoint' => '<string>',
'region' => '<string>',
'replicaConcurrency' => 123,
'responseGracePeriodSeconds' => 123,
'rollOutDurationSeconds' => 123,
'runtime' => '<string>',
'scalingBuffer' => 123,
'scalingMetric' => '<string>',
'scalingTarget' => 123,
'useUv' => true
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://rest.cerebrium.ai/v2/projects/{project_id}/apps"
payload := strings.NewReader("{\n \"cliVersion\": \"<string>\",\n \"name\": \"<string>\",\n \"baseImage\": \"<string>\",\n \"cerebrium_toml\": \"<string>\",\n \"compute\": \"<array>\",\n \"computeTier\": \"<string>\",\n \"cooldownPeriodSeconds\": 123,\n \"cpu\": 123,\n \"deploymentInitializationTimeout\": 123,\n \"disableAuth\": true,\n \"dockerAuth\": \"<string>\",\n \"dockerfilePath\": \"<string>\",\n \"entrypoint\": \"<array>\",\n \"evaluationIntervalSeconds\": 123,\n \"gpuCount\": 123,\n \"healthcheckEndpoint\": \"<string>\",\n \"loadBalancingAlgorithm\": \"<string>\",\n \"logLevel\": \"<string>\",\n \"maxReplicaCount\": 123,\n \"memory\": 123,\n \"minReplicaCount\": 123,\n \"partialUpload\": true,\n \"port\": 123,\n \"provider\": \"<string>\",\n \"pythonVersion\": \"<string>\",\n \"readycheckEndpoint\": \"<string>\",\n \"region\": \"<string>\",\n \"replicaConcurrency\": 123,\n \"responseGracePeriodSeconds\": 123,\n \"rollOutDurationSeconds\": 123,\n \"runtime\": \"<string>\",\n \"scalingBuffer\": 123,\n \"scalingMetric\": \"<string>\",\n \"scalingTarget\": 123,\n \"useUv\": true\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://rest.cerebrium.ai/v2/projects/{project_id}/apps")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"cliVersion\": \"<string>\",\n \"name\": \"<string>\",\n \"baseImage\": \"<string>\",\n \"cerebrium_toml\": \"<string>\",\n \"compute\": \"<array>\",\n \"computeTier\": \"<string>\",\n \"cooldownPeriodSeconds\": 123,\n \"cpu\": 123,\n \"deploymentInitializationTimeout\": 123,\n \"disableAuth\": true,\n \"dockerAuth\": \"<string>\",\n \"dockerfilePath\": \"<string>\",\n \"entrypoint\": \"<array>\",\n \"evaluationIntervalSeconds\": 123,\n \"gpuCount\": 123,\n \"healthcheckEndpoint\": \"<string>\",\n \"loadBalancingAlgorithm\": \"<string>\",\n \"logLevel\": \"<string>\",\n \"maxReplicaCount\": 123,\n \"memory\": 123,\n \"minReplicaCount\": 123,\n \"partialUpload\": true,\n \"port\": 123,\n \"provider\": \"<string>\",\n \"pythonVersion\": \"<string>\",\n \"readycheckEndpoint\": \"<string>\",\n \"region\": \"<string>\",\n \"replicaConcurrency\": 123,\n \"responseGracePeriodSeconds\": 123,\n \"rollOutDurationSeconds\": 123,\n \"runtime\": \"<string>\",\n \"scalingBuffer\": 123,\n \"scalingMetric\": \"<string>\",\n \"scalingTarget\": 123,\n \"useUv\": true\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://rest.cerebrium.ai/v2/projects/{project_id}/apps")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"cliVersion\": \"<string>\",\n \"name\": \"<string>\",\n \"baseImage\": \"<string>\",\n \"cerebrium_toml\": \"<string>\",\n \"compute\": \"<array>\",\n \"computeTier\": \"<string>\",\n \"cooldownPeriodSeconds\": 123,\n \"cpu\": 123,\n \"deploymentInitializationTimeout\": 123,\n \"disableAuth\": true,\n \"dockerAuth\": \"<string>\",\n \"dockerfilePath\": \"<string>\",\n \"entrypoint\": \"<array>\",\n \"evaluationIntervalSeconds\": 123,\n \"gpuCount\": 123,\n \"healthcheckEndpoint\": \"<string>\",\n \"loadBalancingAlgorithm\": \"<string>\",\n \"logLevel\": \"<string>\",\n \"maxReplicaCount\": 123,\n \"memory\": 123,\n \"minReplicaCount\": 123,\n \"partialUpload\": true,\n \"port\": 123,\n \"provider\": \"<string>\",\n \"pythonVersion\": \"<string>\",\n \"readycheckEndpoint\": \"<string>\",\n \"region\": \"<string>\",\n \"replicaConcurrency\": 123,\n \"responseGracePeriodSeconds\": 123,\n \"rollOutDurationSeconds\": 123,\n \"runtime\": \"<string>\",\n \"scalingBuffer\": 123,\n \"scalingMetric\": \"<string>\",\n \"scalingTarget\": 123,\n \"useUv\": true\n}"
response = http.request(request)
puts response.read_body{
"buildId": "<string>",
"dashboardUrl": "<string>",
"internalEndpoint": "<string>",
"keyName": "<string>",
"status": "<string>",
"uploadUrl": "<string>"
}{
"message": "<string>"
}{
"message": "<string>"
}Apps
Create App
Create a new app for a specific project using manual upload.
POST
/
v2
/
projects
/
{project_id}
/
apps
Create App
curl --request POST \
--url https://rest.cerebrium.ai/v2/projects/{project_id}/apps \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"cliVersion": "<string>",
"name": "<string>",
"baseImage": "<string>",
"cerebrium_toml": "<string>",
"compute": "<array>",
"computeTier": "<string>",
"cooldownPeriodSeconds": 123,
"cpu": 123,
"deploymentInitializationTimeout": 123,
"disableAuth": true,
"dockerAuth": "<string>",
"dockerfilePath": "<string>",
"entrypoint": "<array>",
"evaluationIntervalSeconds": 123,
"gpuCount": 123,
"healthcheckEndpoint": "<string>",
"loadBalancingAlgorithm": "<string>",
"logLevel": "<string>",
"maxReplicaCount": 123,
"memory": 123,
"minReplicaCount": 123,
"partialUpload": true,
"port": 123,
"provider": "<string>",
"pythonVersion": "<string>",
"readycheckEndpoint": "<string>",
"region": "<string>",
"replicaConcurrency": 123,
"responseGracePeriodSeconds": 123,
"rollOutDurationSeconds": 123,
"runtime": "<string>",
"scalingBuffer": 123,
"scalingMetric": "<string>",
"scalingTarget": 123,
"useUv": true
}
'import requests
url = "https://rest.cerebrium.ai/v2/projects/{project_id}/apps"
payload = {
"cliVersion": "<string>",
"name": "<string>",
"baseImage": "<string>",
"cerebrium_toml": "<string>",
"compute": "<array>",
"computeTier": "<string>",
"cooldownPeriodSeconds": 123,
"cpu": 123,
"deploymentInitializationTimeout": 123,
"disableAuth": True,
"dockerAuth": "<string>",
"dockerfilePath": "<string>",
"entrypoint": "<array>",
"evaluationIntervalSeconds": 123,
"gpuCount": 123,
"healthcheckEndpoint": "<string>",
"loadBalancingAlgorithm": "<string>",
"logLevel": "<string>",
"maxReplicaCount": 123,
"memory": 123,
"minReplicaCount": 123,
"partialUpload": True,
"port": 123,
"provider": "<string>",
"pythonVersion": "<string>",
"readycheckEndpoint": "<string>",
"region": "<string>",
"replicaConcurrency": 123,
"responseGracePeriodSeconds": 123,
"rollOutDurationSeconds": 123,
"runtime": "<string>",
"scalingBuffer": 123,
"scalingMetric": "<string>",
"scalingTarget": 123,
"useUv": True
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
cliVersion: '<string>',
name: '<string>',
baseImage: '<string>',
cerebrium_toml: '<string>',
compute: '<array>',
computeTier: '<string>',
cooldownPeriodSeconds: 123,
cpu: 123,
deploymentInitializationTimeout: 123,
disableAuth: true,
dockerAuth: '<string>',
dockerfilePath: '<string>',
entrypoint: '<array>',
evaluationIntervalSeconds: 123,
gpuCount: 123,
healthcheckEndpoint: '<string>',
loadBalancingAlgorithm: '<string>',
logLevel: '<string>',
maxReplicaCount: 123,
memory: 123,
minReplicaCount: 123,
partialUpload: true,
port: 123,
provider: '<string>',
pythonVersion: '<string>',
readycheckEndpoint: '<string>',
region: '<string>',
replicaConcurrency: 123,
responseGracePeriodSeconds: 123,
rollOutDurationSeconds: 123,
runtime: '<string>',
scalingBuffer: 123,
scalingMetric: '<string>',
scalingTarget: 123,
useUv: true
})
};
fetch('https://rest.cerebrium.ai/v2/projects/{project_id}/apps', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://rest.cerebrium.ai/v2/projects/{project_id}/apps",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'cliVersion' => '<string>',
'name' => '<string>',
'baseImage' => '<string>',
'cerebrium_toml' => '<string>',
'compute' => '<array>',
'computeTier' => '<string>',
'cooldownPeriodSeconds' => 123,
'cpu' => 123,
'deploymentInitializationTimeout' => 123,
'disableAuth' => true,
'dockerAuth' => '<string>',
'dockerfilePath' => '<string>',
'entrypoint' => '<array>',
'evaluationIntervalSeconds' => 123,
'gpuCount' => 123,
'healthcheckEndpoint' => '<string>',
'loadBalancingAlgorithm' => '<string>',
'logLevel' => '<string>',
'maxReplicaCount' => 123,
'memory' => 123,
'minReplicaCount' => 123,
'partialUpload' => true,
'port' => 123,
'provider' => '<string>',
'pythonVersion' => '<string>',
'readycheckEndpoint' => '<string>',
'region' => '<string>',
'replicaConcurrency' => 123,
'responseGracePeriodSeconds' => 123,
'rollOutDurationSeconds' => 123,
'runtime' => '<string>',
'scalingBuffer' => 123,
'scalingMetric' => '<string>',
'scalingTarget' => 123,
'useUv' => true
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://rest.cerebrium.ai/v2/projects/{project_id}/apps"
payload := strings.NewReader("{\n \"cliVersion\": \"<string>\",\n \"name\": \"<string>\",\n \"baseImage\": \"<string>\",\n \"cerebrium_toml\": \"<string>\",\n \"compute\": \"<array>\",\n \"computeTier\": \"<string>\",\n \"cooldownPeriodSeconds\": 123,\n \"cpu\": 123,\n \"deploymentInitializationTimeout\": 123,\n \"disableAuth\": true,\n \"dockerAuth\": \"<string>\",\n \"dockerfilePath\": \"<string>\",\n \"entrypoint\": \"<array>\",\n \"evaluationIntervalSeconds\": 123,\n \"gpuCount\": 123,\n \"healthcheckEndpoint\": \"<string>\",\n \"loadBalancingAlgorithm\": \"<string>\",\n \"logLevel\": \"<string>\",\n \"maxReplicaCount\": 123,\n \"memory\": 123,\n \"minReplicaCount\": 123,\n \"partialUpload\": true,\n \"port\": 123,\n \"provider\": \"<string>\",\n \"pythonVersion\": \"<string>\",\n \"readycheckEndpoint\": \"<string>\",\n \"region\": \"<string>\",\n \"replicaConcurrency\": 123,\n \"responseGracePeriodSeconds\": 123,\n \"rollOutDurationSeconds\": 123,\n \"runtime\": \"<string>\",\n \"scalingBuffer\": 123,\n \"scalingMetric\": \"<string>\",\n \"scalingTarget\": 123,\n \"useUv\": true\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://rest.cerebrium.ai/v2/projects/{project_id}/apps")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"cliVersion\": \"<string>\",\n \"name\": \"<string>\",\n \"baseImage\": \"<string>\",\n \"cerebrium_toml\": \"<string>\",\n \"compute\": \"<array>\",\n \"computeTier\": \"<string>\",\n \"cooldownPeriodSeconds\": 123,\n \"cpu\": 123,\n \"deploymentInitializationTimeout\": 123,\n \"disableAuth\": true,\n \"dockerAuth\": \"<string>\",\n \"dockerfilePath\": \"<string>\",\n \"entrypoint\": \"<array>\",\n \"evaluationIntervalSeconds\": 123,\n \"gpuCount\": 123,\n \"healthcheckEndpoint\": \"<string>\",\n \"loadBalancingAlgorithm\": \"<string>\",\n \"logLevel\": \"<string>\",\n \"maxReplicaCount\": 123,\n \"memory\": 123,\n \"minReplicaCount\": 123,\n \"partialUpload\": true,\n \"port\": 123,\n \"provider\": \"<string>\",\n \"pythonVersion\": \"<string>\",\n \"readycheckEndpoint\": \"<string>\",\n \"region\": \"<string>\",\n \"replicaConcurrency\": 123,\n \"responseGracePeriodSeconds\": 123,\n \"rollOutDurationSeconds\": 123,\n \"runtime\": \"<string>\",\n \"scalingBuffer\": 123,\n \"scalingMetric\": \"<string>\",\n \"scalingTarget\": 123,\n \"useUv\": true\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://rest.cerebrium.ai/v2/projects/{project_id}/apps")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"cliVersion\": \"<string>\",\n \"name\": \"<string>\",\n \"baseImage\": \"<string>\",\n \"cerebrium_toml\": \"<string>\",\n \"compute\": \"<array>\",\n \"computeTier\": \"<string>\",\n \"cooldownPeriodSeconds\": 123,\n \"cpu\": 123,\n \"deploymentInitializationTimeout\": 123,\n \"disableAuth\": true,\n \"dockerAuth\": \"<string>\",\n \"dockerfilePath\": \"<string>\",\n \"entrypoint\": \"<array>\",\n \"evaluationIntervalSeconds\": 123,\n \"gpuCount\": 123,\n \"healthcheckEndpoint\": \"<string>\",\n \"loadBalancingAlgorithm\": \"<string>\",\n \"logLevel\": \"<string>\",\n \"maxReplicaCount\": 123,\n \"memory\": 123,\n \"minReplicaCount\": 123,\n \"partialUpload\": true,\n \"port\": 123,\n \"provider\": \"<string>\",\n \"pythonVersion\": \"<string>\",\n \"readycheckEndpoint\": \"<string>\",\n \"region\": \"<string>\",\n \"replicaConcurrency\": 123,\n \"responseGracePeriodSeconds\": 123,\n \"rollOutDurationSeconds\": 123,\n \"runtime\": \"<string>\",\n \"scalingBuffer\": 123,\n \"scalingMetric\": \"<string>\",\n \"scalingTarget\": 123,\n \"useUv\": true\n}"
response = http.request(request)
puts response.read_body{
"buildId": "<string>",
"dashboardUrl": "<string>",
"internalEndpoint": "<string>",
"keyName": "<string>",
"status": "<string>",
"uploadUrl": "<string>"
}{
"message": "<string>"
}{
"message": "<string>"
}Authorizations
Service Account Token authentication. To authenticate API requests:
-
Create a Service Account Token:
- Go to the Cerebrium Dashboard and open the API Keys page
- Click Create Service Account, name it (e.g., "GitHub Actions CI/CD"), choose an expiry date, and click Create
- Copy the token generated for the desired service account
-
Use the Token: Include the service account token in the Authorization header of API requests:
Authorization: Bearer <your-service-account-token> -
Best Practices:
- Create separate service accounts for different environments (dev, staging, prod)
- Store tokens securely as secrets in consuming applications or workflows
- Set appropriate expiry dates and rotate tokens regularly
- Never commit tokens to source control
For CI/CD integration examples, see the CI/CD documentation.
Body
application/json
Response
Details of the created app deployment and where to upload the source archive.